; simple screensaver (powersaver)
; -> THIS IS A STUPID PROGRAM!
;    IT WILL NOT: check monitortype, computer
; Idea:
; With no sync, new SVGA monitors will go black and
; within 10 sec switch off
; 
;       DO NOT USE ON OLDER MONITORS
;     DO NOT USE ON MONOCHROME MONITORS
;                NO WARRANTY
; Assembler: DevPac TT
; 7.nov.97: For some reason, the screen _can_ be blanked
;           while moving the mouse. It's very very rare,
;           but a semaphore is implemented now.
;           I'am not sure that I really got it, I just
;           can't imagine a jumping _hz_200.

; 8.feb.98: I am going to make a cookie for PowerSaver
;           This cookie will point to a structure that
;           can be modified by powersav.cpx

;10.Feb 98: Version number to 1.50

	COMMENT HEAD=7		;fastram

_hz_200		equ	$4ba
nvbls		equ	$454
_vblqueue	equ	$456
_p_cookies	equ	$5a0

ps

;First, check out the shifter
	bsr	how_to_save	;check sync

;Now, say hello to user
	lea	TextHello(pc),a0	;say hello
	bsr.s	print

;Insert a cookie
	lea	install_cookies(pc),a0
	bsr	run_sub			;Super mode
	tst	d0
	beq.s	.continue

;Print the cookie errors
	cmp	#2,d0
	beq.s	.c2
.c1	lea	TextCookieError(pc),a0
	bsr.s	print
	bra.s	quit
.c2	lea	TextIsInstalledError(pc),a0
	bsr.s	print
	bra.s	quit

;Insert our mouse and keyboard routines
.continue
	bsr	install_handlers	;insert handlers

;Insert vbl routine (blanker)
	lea	vbl_install(pc),a0
	bsr	run_sub			;should check d0

;Make PowerSaver active
	lea	active(pc),a0
	move	#1,(a0)

;Print out the succesful story
	lea	TextInstalled(pc),a0
	bsr.s	print

;Keep PowerSaver alive
	lea	the_very_end(pc),a0
	move.l	a0,d0
	sub.l	4(sp),d0	;program size
	clr	-(sp)		;Ptermres (TSR)
	move.l	d0,-(sp)
	move	#$31,-(sp)
	trap	#1		;bye bye

;We couldn't install PowerSaver 
quit	lea	TextNotInstalled(pc),a0
	bsr.s	print
	clr	-(sp)
	trap	#1	;bye bye better luck next time


;************************************************
; print out text, a0 points to text
;************************************************

print	pea	(a0)
	move	#9,-(sp)
	trap	#1
	addq.w	#6,sp
	rts

; ***********************************************
; install a cookie into the cookiejar
; we are already in supermode
;  return 0, if ok
;  return 1, if all slots are used
;  return 2, if our cookie was found
; if the cookiejar has no free slots, then we quit
; ***********************************************

install_cookies
	move.l	_p_cookies.w,d0
	beq.s	.InstCookieError
	move.l	d0,a0
;now we have found the cookiejar
;search our cookie and find a free slot

	moveq	#1,d0	;counter
.loop	move.l	(a0)+,d1	;cookie
	move.l	(a0)+,d2	;value
	cmp.l	#'TASC',d1	;our cookie?
	beq.s	.InstErrorFound	;jump if allready installed
	tst.l	d1
	beq.s	.free_cookie			
	addq	#1,d0
	bra.s	.loop
.free_cookie			;a free slot!
	cmp.l	d2,d0		;d2=maximum cookies, d0=used cookies
	bcc.s	.InstCookieError

	subq.w	#8,a0
	move.l	#'TASC',(a0)+
	move.l	#cookie_structure,(a0)+
	move.l	d1,(a0)+	;move null-cookie
	move.l	d2,(a0)		;move null-cookie

	moveq	#0,d0
	rts

.InstCookieError
	moveq	#1,d0
	rts
.InstErrorFound
	moveq	#2,d0
	rts


; ***********************************************
; links our watch routines 
;  checks only ikbd and mouse vectors
; ***********************************************

install_handlers
	move	#34,-(sp)
	trap	#14
	addq.w	#2,sp
	move.l	d0,a0	;KBDVECS
	
	move.l	32(a0),old_ikbd
	move.l	16(a0),old_mouse

	lea	ibkd_check(pc),a1
	move.l	a1,32(a0)
	lea	mouse_check(pc),a1
	move.l	a1,16(a0)

	rts


; **********************************************
; new spy handlers
; Simple but good
;  XBRA structure used
;  These should really be moved to data segment
; Every time time mouse is moved or a key is
; pressed, one of the  handlers will be executed
; **********************************************

	EVEN
	dc.l	'XBRA'
	dc.l	'TASC'
old_ikbd
	dc.l	0

ibkd_check
	addq.w	#1,semaphore
	bsr.s	check_sync_on			;switch on monitor
	subq.w	#1,semaphore
	move.l	old_ikbd(pc),-(sp)	;continue with real handler
	rts

	EVEN
	dc.l	'XBRA'
	dc.l	'TASC'
old_mouse
	dc.l	0

mouse_check
	addq.w	#1,semaphore
	bsr.s	check_sync_on
	subq.w	#1,semaphore
	move.l	old_mouse(pc),-(sp)
	rts

check_sync_on
	move.l	last_time,temp
	move.l	_hz_200.w,last_time
	tst	blank		;is it blanked?
	beq.s	.not_blanked
	move.l	d0,-(sp)
	move.l	_hz_200.w,d0	;current time
	sub.l	temp,d0		;time when activated
	sub.l	total_time,d0	;subtract inactivity time too (included in time)
	bmi.s	.ups		;oh dear!
	add.l	d0,total_active	;add to total time
.ups	move.l	(sp)+,d0
	clr	blank
	move.l	a0,-(sp)	;save a0, just in case
	move.l	turn_on_sync(pc),a0
	jsr	(a0)
	move.l	(sp)+,a0	;restore a0
.not_blanked
	rts

; ***********************************************
; vbl install
; return 0 if not installed
;        1 if installed
; ***********************************************

vbl_install
	move	nvbls.w,d0	;slots
	lsl.w	#2,d0
	move.l	_vblqueue.w,a1
	moveq.l	#4,d1		;slot 1 must be passed!
.search	tst.l	(a1,d1.w)
	beq.s	.found
	addq.w	#4,d1
	cmp.w	d0,d1
	bne.s	.search
	moveq	#0,d0		;not found = we can't blank either
	rts
.found
	lea	powersaver(pc),a0
	move.l	a0,(a1,d1.w)		;install
	move.l	_hz_200.w,last_time	;set time
	moveq	#1,d0
	rts

; ***********************************************
; a VBL routine
; called 50-70 times in 1 sec
;  sync on/off after time
; check if keyboard/mouse (reset time)
; check if time has gone
; we are in super mode
; NOTICE! If the monitor is blanked (no sync)
;  the vbl handler is sleeping too!
; ***********************************************


powersaver
	tst	blank
	bne.s	.vbl_finish	;already blanked (safe check, it would not be used...)
	tst	semaphore
	bne.s	.vbl_finish	;dont blank while updating from kbd or mouse

	move.l	_hz_200.w,d0	;current time
	sub.l	last_time(pc),d0
	cmp.l	total_time(pc),d0
	blo.s	.vbl_finish	;jump if not time to blank

	tst	active		;must be active
	beq.s	.vbl_finish
	move	#1,blank	;so we blanks the monitor

	move.l	remove_sync(pc),a0
	jsr	(a0)		;clear the sync

.vbl_finish
	rts


;************************************************
; setting bit 0 i sync mode register
;  must be in supervision mode
;************************************************

set_bit1
	move.w	d0,-(sp)
	move.b	$ffff820a.w,d0
	bset	#0,d0
	move.b	d0,$ffff820a.w
	move.w	(sp)+,d0
	rts

;************************************************
; clearing bit 0 i sync mode register
;  must be in supervision mode
;************************************************

set_bit0
	move.w	d0,-(sp)
	move.b	$ffff820a.w,d0	;sync mode register
	bclr	#0,d0
	move.b	d0,$ffff820a.w
	move.w	(sp)+,d0
	rts


; ***********************************************
;  Testing the sync mode register.
;  Assuming we are displaying the screen now,
;  we will know how to set/clear the blanking
;  by looking at the current settings
; ***********************************************

how_to_save
	lea	.get_syncmode(pc),a0
	bsr.s	run_sub

	btst	#0,d0
	beq.s	.st_type

;(TT-type)
; setting bit 0 to 0 will turn off sync
	lea	set_bit0(pc),a0
	move.l	a0,remove_sync
	lea	set_bit1(pc),a0
	move.l	a0,turn_on_sync
	bra.s	.fini

.st_type
;setting bit 0 to 1 will turn off sync
	lea	set_bit1(pc),a0
	move.l	a0,remove_sync
	lea	set_bit0(pc),a0
	move.l	a0,turn_on_sync

.fini	rts

.get_syncmode
	move.b	$ffff820A.w,d0	;Sync mode register
	rts


; **********************************************
;  execute a subroutine in super
;  a0 = address
; **********************************************

run_sub
	pea	(a0)
	move	#38,-(sp)
	trap	#14
	addq.w	#6,sp
	rts


; ***********************************************
; some data
; ***********************************************





	DATA

;text-strings

TextHello
	dc.b	13,10,27,'p'
	dc.b	'Powersaver v1.50 (10.feb.98) by T.Andersen'
	dc.b	27,'q',13,10
	dc.b    'This is PD, NO WARRANTY',13,10,0
TextInstalled
	dc.b	'Installed (5 min to blank)',13,10,0
TextNotInstalled
	dc.b	'NOT installed',13,10,0
TextCookieError
	dc.b	'No free slots in cookiejar, install a bigger cookiejar!',13,10,0
TextIsInstalledError
	dc.b	'PowerSaver is allready installed!',13,10,0
	EVEN

last_time	dc.l 0
temp		dc.l 0
; flags

blank		dc.w 0		; 1 if blanked
semaphore	dc.w 0		; >0 if checking kbd or mouse


;total time: 5 (min) * 60 * 200  = 60000

;Well... The cookie will point to this structure

cookie_structure
version		dc.w $0150	;version info
total_time	dc.l 60000	;inactive time to blank (*200)
active		dc.w 0		;powersaver active flag (0 do not blank)
total_active	dc.l 0		;Active PowerSave time (ticks)

	BSS

remove_sync	ds.l 1
turn_on_sync	ds.l 1

the_very_end